/*
	File:		ActionHandlerHeader.h

	Copyright:	 1993-1996 by Apple Computer, Inc., all rights reserved.

*/


#ifndef __ActionHandlerHeader__
#define __ActionHandlerHeader__

//  Action Classes & Identifiers

/*==================================================================================================*/
/*=================================== Script Action Class ==========================================*/
/*==================================================================================================*/
#define	kScriptAction					5000	
#define kPackageNotFoundActStr			"Script Error:  The package with ID=^0 could not be found."
#define	kPackageNotFoundActID			5001	/*	p0 = Package ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kAtomNotFoundInPackageActStr	"Script Error:  The atom of type '^1' with ID=^0 could not be found in the script."
#define	kAtomNotFoundInPackageActID		5002	/*	p0 = Atom ID
													p1 = Atom Type (RsrcType)
													p2 =
													p3 =
													r  = */
#define kFrameworkNotFoundActStr		"Script Error:  The framework ID=^0 could not be found in the script."
#define	kFrameworkNotFoundActID			5003	/*	p0 = Framework ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kRuleNotFoundActStr				"Script Error:  The rule ID=^0 could not be found."
#define	kRuleNotFoundActID				5004	/*	p0 = Rule ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kFileSpecNotFoundActStr			"Script Error:  File Spec ID=^0 could not be found."
#define	kFileSpecNotFoundActID			5005	/*	p0 = File Spec ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kFileSpecIsBadActStr			"Script Error:  File spec ID=^0 is corrupted, most likely the path name."
#define	kFileSpecIsBadActID				5006	/*	p0 = 
													p1 = 
													p2 = 
													p3 =
													r  = */
#define kCouldNotOpenScriptActStr		"Script Error:  The script '^0' could not be opened.  Error ^1."
#define	kCouldNotOpenScriptActID		5007	/*	p0 = ScriptName (Str255*)
													p1 = OSErr
													p2 =
													p3 =
													r  = */
#define kFileSpecIDIsBadActStr			"Script Error:  File spec ID=^0 cannot have this ID number (ID=-32767 is reserved, and ID=0 can only be used for source file specs of atoms that are not copying)."
#define	kFileSpecIDIsBadActID			5008	/*	p0 = File Spec ID
													p1 = 
													p2 = 
													p3 =
													r  = */
#define kAtomIsBadActStr				"Script Error:  Atom of type '^1' and ID=^0 is bad."
#define	kAtomIDIsBadActID				5009	/*	p0 = Atom ID
													p1 = Atom Type (OSType)
													p2 = 
													p3 =
													r  = */
#define kNotEnoughMemoryToReadActStr	"Memory Error:  Ran out of Installer memory while loading script.  Please set the Installer's partition larger."
#define	kNotEnoughMemoryToReadActID		5010	/*	p0 = 
													p1 = 
													p2 = 
													p3 =
													r  = */
#define kSubHeapToSmallActStr 			"Script Error:  The script's sub-heap is too small.  Please set the value in the 'insz' resource higher."
#define	kSubHeapToSmallActID			5011	/*	p0 = 
													p1 = 
													p2 = 
													p3 =
													r  = */
#define kFileSpecNotFndWithRefActStr	"Script Error:  File Spec ID=^0 could not be found.  Referenced from '^1' ID=^2."
#define	kFileSpecNotFndWithRefActID		5012	/*	p0 = File Spec ID
													p1 = Reference Type (RsrcType)
													p2 = Reference ID
													p3 =
													r  = */
#define kVersCompareNotFoundActStr		"Script Error:  The Version Compare resource ('invc') ID=^0 could not be found in the script."
#define	kVersCompareNotFoundActID		5013	/*	p0 = 'invc' resource ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kSearchProcNotFoundActStr		"Script Error:  The Search Procedure resource ('insp') ID=^0 could not be found in the script."
#define	kSearchProcNotFoundActID		5014	/*	p0 = 'insp' resource ID
													p1 =
													p2 =
													p3 =
													r  = */
#define kRuleFunctionNotFoundActStr		"Script Error:  The Rule Function resource ('inrf') ID=^0 could not be found in the script."
#define	kRuleFunctionNotFoundActID		5015	/*	p0 = 'inrf' resource ID
													p1 =
													p2 =
													p3 =
													r  = */

/*==================================================================================================*/
/*====================================== Rule Action Class =========================================*/
/*==================================================================================================*/
#define	kRemapActionResultToCancel		1
#define	kRemapActionResultToError		-1
#define	kRemapActionResultToTRUE		1
#define	kRemapActionResultToFALSE		-1
#define	kDontRemapActionResult			0


#define	kFireRulesAction				5100
#define kFrameworkActStr				"Rule Action:  Framework ID=^0, index ^1 is about to be fired."
#define	kFrameworkActID					5101	/*	p0 = Framework ID
													p1 = Framework Index
													p2 = 
													p3 =
													r  = */
												
#define kRuleResultActStr				"Rule Action:  Rule ID=^0 returned ^1."
#define	kRuleResultActID				5102	/*	p0 = Rule ID
													p1 = Result (TRUE or FALSE)
													p2 = 
													p3 =
													r  = New Result (TRUE or FALSE) */
												
#define kRuleClauseResultActStr			"Rule Action:  Rule Clause index ^1 of rule ID=^0 returned ^2."
#define	kRuleClauseResultActID			5103	/*	p0 = Rule ID
													p1 = Rule Clause Index
													p2 = Result (TRUE or FALSE)
													p3 =
													r  = New Result (TRUE or FALSE)*/


/*==================================================================================================*/
/*===================================== Target Action Class ========================================*/
/*==================================================================================================*/
#define	kTargetAction					5200
#define kTgtFileNotFoundActStr			"Runtime Error:  Target file '^1' was not found (Target File Spec. ID=^0)."		// NOT USED
#define	kTgtFileNotFoundActID			5201	/*	p0 = Target File Spec ID
													p1 = File Name (Str255*)
													p2 = Volume Name (Str255*)
													p3 =
													r  = */
#define kTgtFileLockedActStr			"Runtime Error:  File '^1' is locked (Target File Spec. ID=^0)."				// NOT USED
#define	kTgtFileLockedActID				5202	/*	p0 = Target File Spec ID
													p1 = File Name (Str255*)
													p2 = 
													p3 =
													r  = */
#define kTgtErrForFileAtomActStr 		"Runtime Error:  Problems accessing/writing target file '^1'. Error# ^2. (Target File Spec. ID=^0)."
#define	kTgtErrForFileAtomActID			5203	/*	p0 = Target File Spec ID
													p1 = File Name (Str255*)
													p2 = OSErr
													p3 = Atom ID
													r  = */
#define kTgtErrForRsrcAtomActStr		"Runtime Error:  Problems accessing/writing target resource, type '^1' ID=^2. Error# ^3. (Target File Spec. ID=^0)."
#define	kTgtErrForRsrcAtomActID			5204	/*	p0 = Target File Spec ID
													p1 = Rsrc Type
													p2 = Rsrc ID
													p3 = OSErr
													r  = */
#define kTgtErrForFontAtomActStr		"Runtime Error:  Problems accessing/writing target font ^1. Error# ^2. (Target File Spec. ID=^0)."
#define	kTgtErrForFontAtomActID			5205	/*	p0 = Target File Spec ID
													p1 = Font Name (Str255*)
													p2 = OSErr
													p3 = Atom ID
													r  = */
#define kTgtMatchesSrcErrActStr			"Runtime Error:  The target file ^1 on the volume ^2 matches a source file. (Target File Spec. ID=^0)."
#define	kTgtMatchesSrcErrActID			5206	/*	p0 = Target File Spec ID
													p1 = File Name (Str255*)
													p2 = Source Volume Name (Str255*)
													p3 = 
													r  = */
#define kTgtErrForFolderAtomActStr		"Runtime Error:  Problems accessing/writing target folder ^1. Error# ^2. (Folder Atom ID=^0)."
#define	kTgtErrForFolderAtomActID		5207	/*	p0 = Folder Atom ID
													p1 = File Name
													p2 = OSErr
													p3 = 
													r  = */
#define kTgtErrForResMergeAtomActStr	"Runtime Error:  Problems accessing/writing target file ^1. Error# ^2. (ResMerge Atom ID=^0)."
#define	kTgtErrForResMergeAtomActID	5208	/*	p0 = ResMerge Atom ID
													p1 = File Name
													p2 = OSErr
													p3 = 
													r  = */


/*==================================================================================================*/
/*===================================== Source Action Class ========================================*/
/*==================================================================================================*/
#define	kSourceAction					5300
#define kSrcFileNotFoundActStr			"Runtime Error:  Source File '^1' was not found on the volume '^2'. (Source File Spec. ID=^0)."
#define	kSrcFileNotFoundActID			5301	/*	p0 = Source File Spec ID
													p1 = File Name (Str255*)
													p2 = Volume Name (Str255*)
													p3 =
													r  = */
#define kSrcErrForFileAtomActStr 		"Runtime Error:  Problems reading source file '^1'. Error# ^2. (Source File Spec. ID=^0)."
#define	kSrcErrForFileAtomActID			5302	/*	p0 = Source File Spec ID
													p1 = File Name (Str255*)
													p2 = OSErr
													p3 =
													r  = */
#define kSrcErrForRsrcAtomActStr		"Runtime Error:  Problems reading source resource, type '^1' ID=^2. Error# ^3. (Source File Spec. ID=^0)."
#define	kSrcErrForRsrcAtomActID			5303	/*	p0 = Source File Spec ID
													p1 = Rsrc Type
													p2 = 
													p3 = OSErr
													r  = */
#define kSrcErrForFontAtomActStr		"Runtime Error:  Problems reading source font ^1. Error# ^2. (Source File Spec. ID=^0)."
#define	kSrcErrForFontAtomActID			5304	/*	p0 = Source File Spec ID
													p1 = Font Name
													p2 = OSErr
													p3 = 
													r  = */
#define kSrcErrForFolderAtomActStr		"Runtime Error:  Problems reading source file ^1. Error# ^2. (Folder Atom ID=^0)."
#define	kSrcErrForFolderAtomActID		5305	/*	p0 = Folder Atom ID
													p1 = File Name
													p2 = OSErr
													p3 = 
													r  = */
#define kSrcErrForResMergeAtomActStr	"Runtime Error:  Problems reading source file ^1. Error# ^2. (ResMerge Atom ID=^0)."
#define	kSrcErrForResMergeAtomActID	5306	/*	p0 = ResMerge Atom ID
													p1 = File Name
													p2 = OSErr
													p3 = 
													r  = */


/*==================================================================================================*/
/*===================================== Extender Action Class ======================================*/
/*==================================================================================================*/
#define	kExtenderAction					5400
#define kExtCodeRsrcNotFoundActStr		"Script Error:  Code resource type '^1' ID=^2 was not found for the Atom Extender ID=^0."
#define	kExtCodeRsrcNotFoundActID		5401	/*	p0 = Atom Extender ID
													p1 = Code Rsrc Type
													p2 = Code Rsrc ID
													p3 = 
													r  = */
#define kExtenderRsrcNotFoundActStr		"Script Error:  Atom Extender ID=^0 was not found."
#define	kExtenderRsrcNotFoundActID		5402	/*	p0 = Atom Extender ID
													p1 =
													p2 = 
													p3 =
													r  = */
#define kCallBackNotAvailableActStr		"Runtime Error:  Call back routine, dispatcher number ^0, can not be called now from extender ID=^1."
#define	kCallBackNotAvailableActID		5403	/*	p0 = Atom Extender ID
													p1 = Routine Dispatch Number
													p2 = 
													p3 =
													r  = */
#define kExtenderResultActStr			"Runtime Error:  Atom Extender ID=^0 returned error number ^1."
#define	kExtenderResultActID			5404	/*	p0 = Atom Extender ID
													p1 = Result (OSErr if != 0)
													p2 = 
													p3 =
													r  = */
#define kA5NotSetCorrectlyActStr		"Runtime Error:  Atom Extender ID=^0 called an Installer routine without setting A5 properly."
#define	kA5NotSetCorrectlyActID			5405	/*	p0 = Extender ID
													p1 = 
													p2 = 
													p3 =
													r  = */
#define kTgtSetupProcNotFoundActStr		"Script Error:  Preference setup code resource, type '^1' ID=^0, was not found in the script."
#define	kTgtSetupProcNotFoundActID		5406	/*	p0 = Setup Code Rsrc ID
													p1 = Setup Code Rsrc Type
													p2 = 
													p3 =
													r  = */
#define kVersCodeRsrcNotFoundActStr		"Script Error:  Version code resource, type '^1' ID=^0, was not found in the script."
#define	kVersCodeRsrcNotFoundActID		5407	/*	p0 = Version Code Rsrc ID
													p1 = Version Rsrc Type
													p2 = 
													p3 =
													r  = */
#define kActionAtomCodeRsrcNFActStr		"Script Error:  Action Atom code resource, type '^1' ID=^0, was not found in the script."
#define	kActionAtomCodeRsrcNFActID		5408	/*	p0 = Action Atom Code Rsrc ID
													p1 = Action Atom Rsrc Type
													p2 = 
													p3 =
													r  = */
#define kSearchProcCodeRsrcNFActStr		"Script Error:  Search Proc code resource, type '^1' ID=^0, was not found in the script."
#define	kSearchProcCodeRsrcNFActID		5409	/*	p0 = Search Proc Code Rsrc ID
													p1 = Search Proc Rsrc Type
													p2 = 
													p3 =
													r  = */
#define kSearchProcBadFileActStr		"Runtime Warning:  Skipped found file ^1 returned from Search Proc ID=^0."
#define	kSearchProcBadFileActID			5410	/*	p0 = Search Proc Rsrc ID
													p1 = File Name
													p2 = 
													p3 =
													r  = */
#define kRuleFuncCodeRsrcNFActStr		"Script Error:  Rule Function code resource, type '^1' ID=^0, was not found in the script."
#define	kRuleFuncCodeRsrcNFActID		5411	/*	p0 = Rule Function Code Rsrc ID
													p1 = Rule Function Rsrc Type
													p2 = 
													p3 =
													r  = */
#define kLowModuleSetupMemoryActStr		"Runtime Warning:  Please increase Installer parition.  Could not allocate all requested memory of ^2 for code resource, type '^1' ID=^0."
#define	kLowModuleSetupMemoryActID		5412	/*	p0 = Code Rsrc ID
													p1 = Rsrc Type
													p2 = Requested Memory
													p3 =
													r  = */
#define kNoModuleSetupMemoryActStr		"Runtime Error:  Could not allocate any requested memory of ^2 for code resource, type '^1' ID=^0."
#define	kNoModuleSetupMemoryActID		5413	/*	p0 = Code Rsrc ID
													p1 = Rsrc Type
													p2 = Requested Memory
													p3 =
													r  = */
	
/*==================================================================================================*/
/*===================================== Memory Action Class ========================================*/
/*==================================================================================================*/
#define	kMemoryAction					5500
#define	kFreeMemoryActID				5501
#define	kOutOfMemoryActID				5502

/*==================================================================================================*/
/*==================================== Debugging Action Class ======================================*/
/*==================================================================================================*/
#define	kDebuggingAction				5600
#define kInitializationActStr			"Initializing External Installer Debugger"
#define	kInitializationActID			5601	/*	p0 =
													p1 =
													p2 = 
													p3 =
													r  = OSErr */
#define kCloseActStr					"Closing External Installer Debugger"
#define	kCloseActID						5602	/*	p0 =
													p1 =
													p2 = 
													p3 =
													r  = OSErr */
#define kStdEventActStr					""
#define	kStdEventActID					5603	/*	p0 = Pointer to Installer's EventRecord (you can change it, but be nice)
													p1 =
													p2 = 
													p3 =
													r  =  */

#define kGenericDebugActStr				"^0^1^2^3"
#define	kGenericDebugActID				5604	/*	p0 = Any string
													p1 = Any string
													p2 = Any string
													p3 = Any string
													r  =  */
													
#define kMenuEventActStr				"Menu ID ^0, index ^1."
#define	kMenuEventActID					5605	/*	p0 = Menu ID 
													p1 = Item Index
													p2 = 
													p3 = 
													r  =  */
													

/*==================================================================================================*/
/*===================================== Progress Action Class ======================================*/
/*==================================================================================================*/
#define	kProgressAction					5700
#define kClickedInstallActStr			"Progress:  Beginning installation."
#define	kClickedInstallActID			5701	/*	p0 =
													p1 =
													p2 = 
													p3 =
													r  = */
#define kClickedRemoveActStr			"Progress:  Beginning removal."
#define	kClickedRemoveActID				5702	/*	p0 =
													p1 =
													p2 = 
													p3 =
													r  = */
#define kInstallationResultActStr		"Progress:  Installation ended with the result code #^0."
#define	kInstallationResultActID		5703	/*	p0 = OSErr
													p1 =
													p2 = 
													p3 =
													r  =  */
#define kRemovalResultActStr			"Progress:  Removal ended with the result code #^0."
#define	kRemovalResultActID				5704	/*	p0 = OSErr
													p1 =
													p2 = 
													p3 =
													r  =  */
#define kActionAtomResultActStr			"Progress:  Action Atom ID= ^0 (format 1) returned result ^1 from a ^2 message."
#define	kActionAtomResultActID			5705	/*	p0 = Action Atom ID
													p1 = result (1=cancel, 0=continue, -1=fatalError)
													p2 = stage (0=before, 1=after, 2=cleanUpCancel)
													p3 =
													r  = New Result (1=cancel, 0=continue, -1=fatalError) */


/*==================================================================================================*/
/*======================================= File Progress Actions ====================================*/
/*==================================================================================================*/
#define	kFileProgressAction				5800

													
/*==========File COPY action items================*/
#define kFileCopiedStr					"FILE will be copied ^1 to ^2. (infa#=^0)."
#define	kFileCopiedID					5801	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
													
#define kFileNotCopiedStr				"FILE will NOT be copied ^1, to the disk ^2. (infa#=^0)"
#define	kFileNotCopiedID				5802	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
												
#define kFileNotCopiedNewerLeftStr		"FILE will NOT be copied ^1, to the disk ^2, because the target file is newer.  (infa#=^0)."
#define	kFileNotCopiedNewerLeftID		5803	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
												
#define kFileNotCopiedLockedStr			"FILE will NOT be copied ^1, to the disk ^2, because the target file was locked.  (infa#=^0)."
#define	kFileNotCopiedLockedID			5804	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
													
/*==========File UPDATE action items================*/
#define kFileUpdatedStr					"FILE will be updated ^1, on the disk ^2.  (infa#=^0)."
#define	kFileUpdatedID					5805	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
													
#define kFileNotUpdatedKeptExistStr		"FILE will NOT be updated ^1, on the disk ^2, because the Installer is keeping the existing file. (infa#=^0)."
#define	kFileNotUpdatedKeptExistID		5806	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
																										
#define kFileNotUpdatedNotExistStr		"FILE will NOT be updated ^1, on the disk ^2, because the target file does not exist. (infa#=^0)."
#define	kFileNotUpdatedNotExistID		5807	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */

													
/*==========File REMOVE action items================*/
#define kFileRemovedStr					"FILE will be removed ^1, from the disk ^2. (infa#=^0)."
#define	kFileRemovedID					5808	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume name (Str255)
													p3 =	
													r  = */
													
#define kFileNotRemovedStr				"FILE will NOT be removed ^1, from the disk ^2. (infa#=^0)."
#define	kFileNotRemovedID				5809	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume name (Str255)
													p3 =	
													r  = */
													
#define kFileNotRemovedNoExistStr		"FILE will NOT be removed ^1, from the disk ^2, because it did not exist. (infa#=^0)."
#define	kFileNotRemovedNoExistID		5810	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume name (Str255)
													p3 =	
													r  = */
													
#define kFileNotRemovedLockedStr		"FILE will NOT be removed ^1, from the disk ^2, because it is locked. (infa#=^0)."
#define	kFileNotRemovedLockedID			5811	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume name (Str255)
													p3 =	
													r  = */
													
/*==========Miscellaneous action items================*/
#define kFileSetLockedStr				"The file ^1 will be locked on the disk ^2. (infa#=^0)."
#define	kFileSetLockedID				5812	/*	p0 =	File Atom ID
													p1 =	File Spec ID
													p2 = 	Volume name (Str255)
													p3 =	
													r  = */
													

/*==================================================================================================*/
/*===================================== Resource Progress Actions ==================================*/
/*==================================================================================================*/
#define	kRsrcProgressAction				5900

/*==========Resource COPY action items================*/

#define kRsrcCopiedStr					"RSRC will be copied (Type ^1) into ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcCopiedID					5901	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotCopiedStr				"RSRC will NOT be copied (Type ^1), into the file ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcNotCopiedID				5902	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotCopiedNewerLeftStr		"RSRC will NOT be copied (Type ^1), into the file ^2, on the disk ^3, because the target resource is newer.  (inra#=^0)."
#define	kRsrcNotCopiedNewerLeftID		5903	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotCopiedNotTargetStr		"RSRC will NOT be copied (Type ^1), because the target file ^2 needs to exist on the disk ^3.  (inra#=^0)."
#define	kRsrcNotCopiedNotTargetID		5904	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
												
#define kRsrcNotCopiedProtectedStr		"RSRC will NOT be copied (Type ^1), into the file ^2, because the target resource was protected on the disk ^3.  (inra#=^0)."
#define	kRsrcNotCopiedProtectedID		5905	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
												
												
/*==========Resource UPDATE action items================*/
#define kRsrcUpdatedStr					"RSRC will be updated (Type ^1) in the file ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcUpdatedID					5906	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotUpdatedKeptExistStr		"RSRC will NOT be updated (Type ^1), in the file ^2, because the Installer is keeping the existing resource on the disk ^3.  (inra#=^0)."
#define	kRsrcNotUpdatedKeptExistID		5907	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotUpdatedLockedStr		"RSRC will NOT be updated (Type ^1), because the target file ^2 contains a resource that is locked on the disk ^3.  (inra#=^0)."
#define	kRsrcNotUpdatedLockedID			5908	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotUpdatedNotExistStr		"RSRC will NOT be updated (Type ^1), in the file ^2, because it didn't exist on the disk ^3.  (inra#=^0)."
#define	kRsrcNotUpdatedNotExistID		5909	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotUpdatedProtectedStr		"RSRC will NOT be updated (Type ^1), because the target resource was locked in the file ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcNotUpdatedProtectedID		5910	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
													
/*==========Resource REMOVE action items================*/

#define kRsrcRemovedStr					"RSRC will be removed (Type ^1) from the file ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcRemovedID					5911	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotRemovedStr				"RSRC will NOT be removed (Type ^1), from the file ^2 on the disk ^3.  (inra#=^0)."
#define	kRsrcNotRemovedID				5912	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotRemovedNoExistStr		"RSRC will NOT be removed (Type ^1), from the file ^2, because it doesn't exist on the disk ^3.  (inra#=^0)."
#define	kRsrcNotRemovedNoExistID		5913	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotRemovedProtectedStr		"RSRC will NOT be removed (Type ^1), from the file ^2, because the resource is protected on the disk ^3.  (inra#=^0)."
#define	kRsrcNotRemovedProtectedID		5914	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kRsrcNotRemovedLockedStr		"RSRC will NOT be removed (Type ^1), because the file ^2 is Locked on the disk ^3.  (inra#=^0)."
#define	kRsrcNotRemovedLockedID			5915	/*	p0 =	Rsrc Atom ID
													p1 =	Rsrc Type/Rsrc ID (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */												
												
/*==================================================================================================*/
/*====================================== Font Progress Actions =====================================*/
/*==================================================================================================*/
#define	kFontProgressAction				6000

/*==========Font COPY action items================*/

#define kFontCopiedStr					"FONT will be copied ^1 into ^2 on the disk ^3.  (inff#=^0)."
#define	kFontCopiedID					6001	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotCopiedStr				"FONT will NOT be copied ^1 into the file ^2 on the disk ^3.  (inff#=^0)."
#define	kFontNotCopiedID				6002	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
/*==========Font UPDATE action items================*/
												
												
#define kFontUpdatedStr					"FONT will be updated ^1 in the file ^2 on the disk ^3.  (inff#=^0)."
#define	kFontUpdatedID					6003	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
												
#define kFontNotUpdatedKeptExistStr		"FONT will NOT be updated ^1, in the file ^2 on the disk ^3, because the Installer is keeping the existing font.  (inff#=^0)."
#define	kFontNotUpdatedKeptExistID		6004	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotUpdatedLockedStr		"FONT will NOT be updated ^1, in the file ^2 on the disk ^3, because the target file is locked.  (inff#=^0)."
#define	kFontNotUpdatedLockedID			6005	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotUpdatedNotExistStr		"FONT will NOT be updated ^1, in the file ^2 on the disk ^3, because the target font did not exist.  (inff#=^0)."
#define	kFontNotUpdatedNotExistID		6006	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotUpdatedProtectedStr		"FONT will NOT be updated ^1, in the file ^2 on the disk ^3, because a target font resource is protected.  (inff#=^0)."
#define	kFontNotUpdatedProtectedID		6007	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
/*==========Font REMOVE action items================*/
													
#define kFontRemovedStr					"FONT will be removed ^1, from the file ^2 on the disk ^3.  (inff#=^0)."
#define	kFontRemovedID					6008	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotRemovedStr				"FONT will NOT be removed ^1, from the file ^2 on the disk ^3.  (inff#=^0)."
#define	kFontNotRemovedID				6009	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotRemovedNoExistStr		"FONT will NOT be removed ^1, from the file ^2 on the disk ^3, because it doesn't exist.  (inff#=^0)."
#define	kFontNotRemovedNoExistID		6010	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotRemovedLockedStr		"FONT will NOT be removed ^1, from the file ^2 on the disk ^3, because the target file is locked.  (inff#=^0)."
#define	kFontNotRemovedLockedID			6011	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													
#define kFontNotRemovedProtectedStr		"FONT will NOT be removed ^1, from the file ^2 on the disk ^3, because a target font resource is protected.  (inff#=^0)."
#define	kFontNotRemovedProtectedID		6012	/*	p0 =	Font Atom ID
													p1 =	Family Name (Str255)
													p2 = 	File Spec ID
													p3 =	Volume Name (Str255)
													r  = */
													

/*==================================================================================================*/
/*===================================== Folder Progress Actions ====================================*/
/*==================================================================================================*/
#define	kFolderProgressAction			6100

#define kFolderCopiedStr				"FOLDER will be copied ^1 to the disk ^2.  (Folder Atom ID=^0)."
#define	kFolderCopiedID					6101	/*	p0 =	Folder Atom ID
													p1 =	Folder Name (Str255)
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
													
/*==================================================================================================*/
/*===================================== ResMerge Progress Actions ==================================*/
/*==================================================================================================*/
#define	kResMergeProgressAction		6200

#define kResMergeCopiedStr				"RESOURCES will be merged into the file ^1 on the disk ^2.  (ResMerge Atom ID=^0)."
#define	kResMergeCopiedID				6201	/*	p0 =	ResMerge Atom ID
													p1 =	File Name (Str255)
													p2 = 	Volume Name (Str255)
													p3 =	
													r  = */
													
													

/*==================================================================================================*/
/*===================================== HandleAction Function ======================================*/
/*==================================================================================================*/

#ifndef Rez

#ifndef __Types__
#include "Types.h"
#endif

#ifndef __InstallerScript__
#include "InstallerScript.h"
#endif

/* commented out because this is defined in the new 4.1 "InstallerScript.h" file
typedef struct{
	Handle				fStaticDataHdl;
	InstallerCallBackUPP	fCallBackProcPtr;
	short				fTargetVRefNum;
	long				fTargetFolderDirID;
	short				fSystemVRefNum;
	long				fSystemBlessedDirID;
	short				fActionClassID;
	short				fActionIdentifier;
	void*				fParam0;
	void*				fParam1;
	void*				fParam2;
	void*				fParam3;	
	void*				fResultPtr;
} ActionHandlerPB, *ActionHandlerPBPtr;
*/

OSErr HandleAction( ActionHandlerPBPtr );



/* This is the interface for the call back routine to send actions from code resources.
	You can NOT send actions using RegisterScriptAction() while inside an Action Handler code resource. */

void RegisterScriptAction( 	InstallerCallBackUPP	pCallBackProcPtr,
							short					actionClassID,
							short					actionIdentifier,
							void*					param0,
							void*					param1,
							void*					param2,
							void*					param3,
							void*					resultPtr  );

#endif

#endif