
#include "InstallerScript.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//											Memory Related
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

Handle INewHandle( 	InstallerCallBackUPP	pCallBackProcPtr,
					unsigned long			pLenth )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 29;
	theCallBackPBRec.fParam[0] = (long)pLenth;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return (Handle)theCallBackPBRec.fResult;
}


void IDisposHandle( InstallerCallBackUPP	pCallBackProcPtr,
					Handle					pHandle )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector 	= 30;
	theCallBackPBRec.fParam[0] 	= (long)pHandle;
	theCallBackPBRec.fResult 	= noErr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	


void IHLock( 	InstallerCallBackUPP	pCallBackProcPtr,
				Handle					pHandle )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector 	= 31;
	theCallBackPBRec.fParam[0] 	= (long)pHandle;
	theCallBackPBRec.fResult 	= noErr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	


void IHUnLock( 	InstallerCallBackUPP	pCallBackProcPtr,
				Handle					pHandle )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector 	= 32;
	theCallBackPBRec.fParam[0] 	= (long)pHandle;
	theCallBackPBRec.fResult 	= noErr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	
	


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//											Atom Extender Related
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

OSErr ReadSourceData( 	InstallerCallBackUPP	pCallBackProcPtr,
						long*					pCount, 
						Ptr						pStoragePtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 21;
	theCallBackPBRec.fParam[0] = (long)pCount;
	theCallBackPBRec.fParam[1] = (long)pStoragePtr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	

	
OSErr WriteTargetData( 	InstallerCallBackUPP	pCallBackProcPtr,
						long					pCount, 
						Ptr						pStoragePtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 22;
	theCallBackPBRec.fParam[0] = (long)pCount;
	theCallBackPBRec.fParam[1] = (long)pStoragePtr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	
OSErr ReadTargetData( 	InstallerCallBackUPP	pCallBackProcPtr,
						long*					pCount, 
						Ptr						pStoragePtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 34;
	theCallBackPBRec.fParam[0] = (long)pCount;
	theCallBackPBRec.fParam[1] = (long)pStoragePtr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	

OSErr SetTargetDataPos( InstallerCallBackUPP	pCallBackProcPtr,
						short					pPositionMode, 
						long					pPositionOffset )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 23;
	theCallBackPBRec.fParam[0] = (long)pPositionMode;
	theCallBackPBRec.fParam[1] = pPositionOffset;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	
OSErr GetTargetDataPos( InstallerCallBackUPP	pCallBackProcPtr,
						long*					pPositionOffset )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 24;
	theCallBackPBRec.fParam[0] = (long)pPositionOffset;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	
OSErr GetTargetDataEOF( InstallerCallBackUPP	pCallBackProcPtr,
						long*					pLength )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 25;
	theCallBackPBRec.fParam[0] = (long)pLength;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	
OSErr SetSourceDataPos( InstallerCallBackUPP	pCallBackProcPtr,
						short					pPositionMode, 
						long					pPositionOffset )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 26;
	theCallBackPBRec.fParam[0] = (long)pPositionMode;
	theCallBackPBRec.fParam[1] = pPositionOffset;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	
OSErr GetSourceDataPos( InstallerCallBackUPP	pCallBackProcPtr,
						long*					pPositionOffset )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 27;
	theCallBackPBRec.fParam[0] = (long)pPositionOffset;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	
	

OSErr GetSourceDataEOF( InstallerCallBackUPP	pCallBackProcPtr,
						long*					pLength )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 28;
	theCallBackPBRec.fParam[0] = (long)pLength;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	

/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//											Action Atom Related
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

OSErr MakeFSSpecFromFileSpecID( InstallerCallBackUPP	pCallBackProcPtr,
								short					pFileSpecID,
								FSSpec*					pFSSpecPtr,
								StringHandle*			pExtraPathInfo )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 35;
	theCallBackPBRec.fParam[0] = (long)pFileSpecID;
	theCallBackPBRec.fParam[1] = (long)pFSSpecPtr;
	theCallBackPBRec.fParam[2] = (long)pExtraPathInfo;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	


void SuspendWaitCursor( InstallerCallBackUPP	pCallBackProcPtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 36;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	


void ResumeWaitCursor(  InstallerCallBackUPP	pCallBackProcPtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 37;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	


void IncrementStatusBar(	InstallerCallBackUPP	pCallBackProcPtr,
							short					pIncrementAmount)

{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 38;
	theCallBackPBRec.fParam[0] = (long)pIncrementAmount;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	


Boolean IsUserInteractionAllowed( InstallerCallBackUPP	pCallBackProcPtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 39;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
	return theCallBackPBRec.fResult;
}	


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//											Debugging Related
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

void RegisterScriptAction( 	InstallerCallBackUPP	pCallBackProcPtr,
							short					actionClassID,
							short					actionIdentifier,
							void*					param0,
							void*					param1,
							void*					param2,
							void*					param3,
							void*					resultPtr )
{
	CallBackPBRec	theCallBackPBRec;
	
	theCallBackPBRec.fSelector = 33;
	theCallBackPBRec.fParam[0] = (long)actionClassID;
	theCallBackPBRec.fParam[1] = (long)actionIdentifier;
	theCallBackPBRec.fParam[2] = (long)param0;
	theCallBackPBRec.fParam[3] = (long)param1;
	theCallBackPBRec.fParam[4] = (long)param2;
	theCallBackPBRec.fParam[5] = (long)param3;
	theCallBackPBRec.fParam[6] = (long)resultPtr;
	CallInstallerCallBackProc(pCallBackProcPtr, &theCallBackPBRec);
}	
	
