{
	File:		TargetVersMgt.p

	Contains:	xxx put contents here xxx

	Written by:	Kevin Aitken

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 4/17/94	KBA		Added support for new format of the target info and target vers
									parameter blocks passed to the extension code resources.
		 <1>	11/10/93	KBA		first checked in

}




UNIT TargetVersMgt;

{****************************************} INTERFACE {****************************************}

USES Files;

CONST
	kVersTypeIsFile		= -1;
	kVersTypeIsRsrc		= 1;

TYPE
	VersTypes =	(fileVersPB, rsrcVersPb);
	TargetVersPB = RECORD
		fSrcFSSpec			: FSSpec;
		fSrcDataType		: LongInt;
		CASE VersTypes OF
			fileVersPB:
				(
					fTgtFileName		: Str31;
					fTgtVersionNum		: LongInt;	
					fTgtFileType		: ResType;	{ Not supported in 4.0.0 }
					fTgtFileCreator		: ResType;	{ Not supported in 4.0.0 }
				);
				
			rsrcVersPb:
				(
					fSrcRsrcType		: OSType;	
					fSrcRsrcID			: INTEGER;
					fTgtRsrcType		: OSType;	
					fTgtRsrcID			: INTEGER;
					fTgtRsrcVersionNum	: LongInt;	
				);
		END;

	
	TargetVersPBPtr =	^TargetVersPB;


FUNCTION GetTgtVersForVersionCompare(	pAccessoriesFileRefNum 	: INTEGER;
										pVersCompareProcID		: INTEGER;
										pTgtVersPBPtr			: TargetVersPBPtr ) : OSErr;

IMPLEMENTATION
	{ Implemented in C in TargetVersMgt.c }

END.		{ TargetVersMgt UNIT }






